##############################################
package aims2winsrvc;
##############################################

use strict;
use SOAP::Lite;

1;

##############################################
sub new
##############################################
{
   my($class) = @_;
   my($self) = bless {}, $class;
   return $self;
}

# https://winservices-soap.web.cern.ch/winservices-soap/Generic/Authentication.asmx/UserIsMemberOfGroup
# works recursively for all variants of username/group (ie: user/group , user@cern.ch/group@cern.ch .. etc)

##############################################
sub userismemberofgroup
##############################################
{
   my($self, $conf, $user, $group) = @_;

   unless($user){ return 0; } # no user ??
   unless($group){ return 0; } # no group in landb ??

   my $winsrvcep    = $conf->{_CONF}->{'WINSRVC_EP'} ? $conf->{_CONF}->{'WINSRVC_EP'} : die "Error: WINSRVC_EP is undefined.\n";
   my $winsrvcproxy = $conf->{_CONF}->{'WINSRVC_PROXY'} ? $conf->{_CONF}->{'WINSRVC_PROXY'} : die "Error: WINSRVC_PROXY is undefined.\n";
   our $winsrvcuser  = $conf->{_CONF}->{'WINSRVC_USER'} ? $conf->{_CONF}->{'WINSRVC_USER'} : die "Error: WINSRVC_USER is undefined.\n";
   our $winsrvcpass  = $conf->{_CONF}->{'WINSRVC_PASS'} ? $conf->{_CONF}->{'WINSRVC_PASS'} : die "Error: WINSRVC_PASS is undefined.\n";

   sub SOAP::Transport::HTTP::Client::get_basic_credentials { 
       return $winsrvcuser => $winsrvcpass;
   }   

   my $conn= SOAP::Lite->uri($winsrvcep)->on_action( sub { "$_[0]/$_[1]" })->proxy($winsrvcproxy);
   my $res=$conn->UserIsMemberOfGroup(SOAP::Data->name('UserName' => $user),SOAP::Data->name('GroupName' => $group));    

   if ($res->fault) { return 0; } # problem, or user account blocked/non-active

   if ($res->result eq 'true') { return 1; }
 
   return 0;  
   
}


