#!/usr/bin/perl

##############################################
#
# aims2 Post Reboot CGI.
#
# Prevents hosts from going into endless install loops.
#
##############################################

use strict;
use CGI qw(param);
use Socket;
use aims2server::conf;
use aims2server::db;
use aims2server::host;
use aims2server::pxe;

print "Content-type: text/html\n\n";
my $iaddr = inet_aton( $ENV{REMOTE_ADDR} ); # or whatever address
my( $HOST, $DOMAIN, $C)  = split(/\./, gethostbyaddr($iaddr, AF_INET));
exit 1 if!$HOST;
$HOST =~ tr/[A-Z]/[a-z]/;

# FIXME: Set all devices to locaboot when hit.

my $dbconn = $aims2conf::db_conn_string;
my $dbuser = $aims2conf::db_user;
my $dbpass = $aims2conf::db_pass;
my %dbattr = %aims2conf::db_conn_attrib;

my $db = aims2db->new();
my $dbh = $db->Connect($dbconn,$dbuser,$dbpass,%dbattr);

my $host = aims2host->new($dbh, "aims2reboot", {});
my $reg = $host->get_device_by_name($HOST);
unless(values %$reg){
   print "$HOST is not registered with aims2. No action taken.";
   exit 1;
}

my $pxe = aims2pxe->new($dbh, "aims2reboot", {});
   $pxe->disable($HOST);

print "$HOST.$DOMAIN.$C installed by AIMS2 at ".localtime()."\n\nDevice set to localboot.";
exit 1;
